﻿#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>

using ll = long long;
using db = double;
const int inf = 10000000009;
using namespace std;


void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n, vector<int>());
    vector <bool> used(n, 0);
    vector <int> degs(n, 0);
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--; u--;
        g[v].push_back(u);
        degs[v]++;
    }
    vector <pair<int, int>> res(n);
    for (int i = 0; i < n; i++) {
        res[i] = { degs[i], i };
    }
    sort(res.rbegin(), res.rend());
    int k = 0;
    for (auto el : res) {
        int v = el.second;
        used[v] = 1;
        for (int u : g[v]) {
            if (!used[u])
                k++;
        }
    }
    if (m - k >= (m / 2) + m % 2) {
        reverse(res.begin(), res.end());
        for (auto el : res) {
            cout << el.second + 1 << " ";
        }
        cout << endl;
    }
    else if (k >= (m / 2) + m % 2) {
        for (auto el : res) {
            cout << el.second + 1 << " ";
        }
        cout << endl;
    }
    else {
        cout << -1 << endl;
    }
}

/*
const int maxn = 10e6;
vector<bool> visited;
vector<pair<int, int>> ans;

int tout = 1;
int k = 0;
void dfs(int v, vector<vector<int>>& g) {
    for (auto u : g[v]) {
        if (!visited[u]) {
            visited[u] = true;
            dfs(u, g);
            ans.push_back({tout, u});
        }
        else {
            k++;
        }
    }
    tout += 1;
}

void solve() {
    int n, m;
    cin >> n >> m;
    k = 0;
    vector<vector<int>> g(n, vector<int>());
    visited.assign(n, 0);
    ans.clear();
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--; u--;
        g[v].push_back(u);
    }
    for (int v = 0; v < n; v++) {
        if (!visited[v]) {
            visited[v] = true;
            dfs(v, g);
            ans.push_back({ tout, v});
            tout += 1;
        }
    }
    if (n - 1 < m) {
        cout << -1  << " " << k << endl;
        return;
    }
    
    sort(ans.begin(), ans.end(), greater<pair<int, int>>());
    for (auto u : ans) {
        cout << u.second + 1 << " ";
    }
    cout << endl;
}
*/



int main(){

#ifdef DEBUG
    auto f = freopen("test.txt", "r", stdin);
    cout << "Debug Mode" << endl;
#endif // DEBUG
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    
}


