#include <bits/stdc++.h>

#define int long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using ll = long long;
using ld = long double;

using namespace std;

vector<vector<int>> g;
vector<int> seen;
vector<int> topsort;


void dfs(int v){
    seen[v] = 1;

    for(auto& to : g[v]){
        if(seen[to]) continue;

        dfs(to);
    }

    topsort.push_back(v);
}

void solve(){
    int n, m;

    cin >> n >> m;

    vector<pair<int, int>> edges(m);

    g.assign(n, vector<int>());
    seen.assign(n, 0);
    topsort.clear();

    for(int i = 0 ; i < m; ++i){
        int x, y;

        cin >> x >> y;

        --x; --y;

        edges[i] = {x, y};

        g[x].push_back(y);
    }

    for(int i = 0; i < n; ++i){
        if(!seen[i]) dfs(i);
    }

    reverse(all(topsort));

    vector<int> time(n);

    for(int i = 0; i < n; ++i){
        time[topsort[i]] = i;
    }

    int cnt1 = 0;

    for(int i = 0; i < m; ++i){
        if(time[edges[i].first] < time[edges[i].second]){
            ++cnt1;
        }
    }

    reverse(all(topsort));

    int cnt2 = 0;

    for(int i = 0; i < m; ++i){
        if(time[edges[i].first] < time[edges[i].second]){
            ++cnt2;
        }
    }

    if(cnt1 >= (m - 1) / 2 + 1){
        for(int i = n - 1; i >= 0; --i){
            cout << topsort[i] + 1 << ' ';
        }

        cout << endl;
    }else if(cnt2 >= (m - 1) / 2 + 1){
        for(int i = 0; i < n; ++i){
            cout << topsort[i] + 1 << ' ';
        }

        cout << endl;
    }else{
        cout << -1 << endl;
    }
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;

    cin >> t;

    while(t--){
        solve();
    }

    return 0;
}
