#include <iostream>
#include "bits/stdc++.h"


#define int long long
using namespace std;


struct tree {
    int n;
    vector<int> t;

    void init(int n) {
        this->n = n;
        t.resize(n * 4);
    }

    int merge(const int &a, const int &b) {
        return (a + b);
    }

    void build(const vector<int> &a) {
        build(1, 0, (this->n) - 1, a);
    }

    void build(int v, int l, int r, const vector<int> &a) {
        if (l == r) {
            t[v] = a[l];
            return;
        }
        int m = l + (r - l) / 2;
        build(v * 2, l, m, a);
        build(v * 2 + 1, m + 1, r, a);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    void update(const int &x, const int &pos) {
        update(1, 0, (this->n) - 1, x, pos);
    }

    void update(int v, int tl, int tr, const int &x, const int &pos) {
        if (tl == tr) {
            t[v] = x;
            return;
        }

        int tm = tl + (tr - tl) / 2;
        if (tl <= pos && pos <= tm) {
            update(v * 2, tl, tm, x, pos);
        } else if (tm < pos && pos <= tr) {
            update(v * 2 + 1, tm + 1, tr, x, pos);
        } else {
            cerr << "Error: " << pos << "is out of bound" << endl;
        }
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    int get(int l, int r) {
        return get(1, 0, (this->n) - 1, l, r);
    }

    int get(int v, int tl, int tr, int l, int r) {
        if (tl > tr || r < l) {
            return 0;
        } else if (tl >= l && tr <= r) {
            return t[v];
        }

        int tm = tl + (tr - tl) / 2;
        return get(v * 2, tl, tm, l, min(r, tm)) + get(v * 2 + 1, tm + 1, tr, max(l, tm), r);
    }
};

signed solve_a() {
    int h, l;
    cin >> l >> h;
    cout<<(h-(int)(l%2 == 0 && h%2 != 0))<<endl;

    return 0;
}

int solve_f() {
    int count;
    cin >> count;
    vector<int> time(count);
    for (int i = 0; i < count; i++) {
        int first, second;
        char ch;
        cin >> first >> ch >> second;
        time[i] = first * 60 + second;
    }
    if (count == 1) {
        return 2;
    }

    for (int i = 0; i < count - 2; i++) {
        if (time[i + 2] - time[i] <= 10){
            return 0;
        }
    }

    for (int i = 0; i < count - 1; i++){
        if(time[i + 1] - time[i] <= 10){
            return 1;
        }
    }

    return 2;

}

signed main() {

    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int test = 1;
    // cin >> test;
    while (test--) {
        solve_a();
    }

    return 0;
}
