//
// Created by Guest_517.group on 16.11.2024.
//

#include <iostream>
#include "bits/stdc++.h"

#include <unordered_set>

#define int long long
using namespace std;


struct tree {
    int n;
    vector<int> t;

    void init(int n) {
        this->n = n;
        t.resize(n * 4);
    }

    int merge(const int &a, const int &b) {
        return (a + b);
    }

    void build(const vector<int> &a) {
        build(1, 0, (this->n) - 1, a);
    }

    void build(int v, int l, int r, const vector<int> &a) {
        if (l == r) {
            t[v] = a[l];
            return;
        }
        int m = l + (r - l) / 2;
        build(v * 2, l, m, a);
        build(v * 2 + 1, m + 1, r, a);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    void update(const int &x, const int &pos) {
        update(1, 0, (this->n) - 1, x, pos);
    }

    void update(int v, int tl, int tr, const int &x, const int &pos) {
        if (tl == tr) {
            t[v] = x;
            return;
        }

        int tm = tl + (tr - tl) / 2;
        if (tl <= pos && pos <= tm) {
            update(v * 2, tl, tm, x, pos);
        } else if (tm < pos && pos <= tr) {
            update(v * 2 + 1, tm + 1, tr, x, pos);
        } else {
            cerr << "Error: " << pos << "is out of bound" << endl;
        }
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    int get(int l, int r) {
        return get(1, 0, (this->n) - 1, l, r);
    }

    int get(int v, int tl, int tr, int l, int r) {
        if (tl > tr || r < l) {
            return 0;
        } else if (tl >= l && tr <= r) {
            return t[v];
        }

        int tm = tl + (tr - tl) / 2;
        return get(v * 2, tl, tm, l, min(r, tm)) + get(v * 2 + 1, tm + 1, tr, max(l, tm), r);
    }
};

void solve_l() {
    int n, m;
    cin >> n >> m;
}

int get_min_k(int min_el, int first, int second) {
    return min(first - min_el, (second - min_el) / 2);
}

void solve_k() {
    int num_count;
    cin >> num_count;
    vector<int> nums(num_count);
    for (auto &el : nums) {
        cin >> el;
    }
    for (int _ = 0; _ < 10; _++) {
        int min_el = 1e18;

        for (int i = 0; i < nums.size(); i++) {
            min_el = min(min_el, nums[i]);
        }

        for (int i = 0; i < nums.size(); i++) {
            int k = get_min_k(min_el, nums[i], nums[(i + 1) % num_count]);
            nums[i] -= k;
            nums[(i + 1) % num_count] -= 2 * k;
        }
        bool is_not_same = false;
        for (int i = 0; i < nums.size(); i++) {
            if (nums[i] != nums[(i + 1) % num_count]) {
                is_not_same = true;
                break;
            }
        }

        if (!is_not_same) {
            cout << max(nums[0], (int)0) << '\n';
            return;
        }

        for (int i = 0; i < nums.size(); i++) {
            if (nums[i] == min_el) {
                int k = (nums[(i + 1) % num_count] - nums[i]);
                nums[i] -= k;
                nums[(i + 1) % num_count] -= 2 * k;
            }
        }
    }
    cout << 0 << '\n';
    return;
}

signed main() {

    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int test = 1;
    cin >> test;
    while (test--) {
        solve_k();
    }

    return 0;
}
