#include <iostream>
#include <string>
#include <limits>
#include <cmath>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>

using namespace std;

int n, e;
unordered_set<char> impossible, not_interested, possible;
string answer = "-";

char find_char(unordered_map<char, int>& m) {
    for (auto c : possible)
        if (!m.count(c))
            return c;

    return '#';
}


void helper(vector<string> &arr, vector<int>& states, unordered_map<char, int>& m, string & cur, int d) {
    if (d > 4) return;

    if (answer.size() <= cur.size() && answer != "-")
        return;

    char p = find_char(m);
    if (p != '#') {
        cur += p;
        if (answer.size() > cur.size() || answer == "-")
            answer = cur;
        cur.pop_back();
        return;
    }

    for (int i = 0; i < arr.size(); ++i) {
        cur.push_back(arr[i][states[i]]);
        m[arr[i][states[i]]]--;
        if (m[arr[i][states[i]]] == 0)
            m.erase(arr[i][states[i]]);

        states[i] = (states[i] + 1) % arr[i].size();
        m[arr[i][states[i]]]++;

        helper(arr, states, m, cur, d + 1);

        cur.pop_back();
        m[arr[i][states[i]]]--;
        if (m[arr[i][states[i]]] == 0)
            m.erase(arr[i][states[i]]);

        states[i] = (states[i] - 1 + arr[i].size()) % arr[i].size();
        m[arr[i][states[i]]]++;
    }
}



int main() {
    cin >> n >> e;


    for(char a = 'a'; a <= ('a' + e - 1); a++)
        impossible.insert(a);

    vector<string> arr(n);
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
        char c = arr[i][0];
        bool flag = true;
        for (int j = 0; j < arr[i].size(); ++j) {
            if (arr[i][j] != c) flag = false;
            impossible.erase(arr[i][j]);
        }
        if (flag) not_interested.insert(c);
    }

    for(char a = 'a'; a <= ('a' + e - 1); a++)
        if (!impossible.count(a))
            possible.insert(a);

    if (!impossible.empty()) {
        cout << *impossible.begin();
    } else if (not_interested.size() == e) {
        cout << "NO";
    } else {
        vector<int> states(n);
        unordered_map<char, int> m;

        for (int i = 0; i < n; ++i)
            m[arr[i][0]]++;

        string cur;
        helper(arr, states, m, cur, 0);
        cout << (answer == "-" ? "NO" : answer);
    }
}

