﻿#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma comment(linker, "/STACK:67108864")

#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <random>
#include <string>

#define ll long long

using namespace std;

const int N = 102;
const int MOD = 998244353;

int dp[N][1 << 16][1 << 3];
int dp2[N][1 << 3][2]; // dp[len][last][ok]

int add(int x, int y) {
    int res = x + y;
    if (res >= MOD) {
        return res - MOD;
    }
    return res;
}

bool inside(int out, int in, int out_size, int in_size) {
    for (int s = 0; in_size + s <= out_size; s++) {
        int temp = (out >> s) & ((1 << in_size) - 1);
        if (temp == in) {
            return true;
        }
    }
    return false;
}

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    int good = 0;
    for (int i = 0; i < k; i++) {
        char x;
        cin >> x;
        good = (good << 1) | (x == '1');
    }
    if (n > m) {
        swap(n, m);
    }

    int p = 1 << k;
    int l = p - 1;
    int k1 = k + 1;
    int p1 = 1 << k1;
    int l1 = p1 - 1;
    int cm = 1 << p1;

    if (n == k) {
        for (int last = 0; last < p; last++) {
            dp[k][last][last == good] = 1;
        }
        for (int i = k; i < m; i++) {
            for (int last = 0; last < p; last++) {
                for (int ok = 0; ok <= 1; ok++) {
                    for (int bit = 0; bit <= 1; bit++) {
                        int new_last = ((last << 1) | bit) & l;
                        dp[i + 1][new_last][ok || (new_last == good)] =
                            add(dp[i + 1][new_last][ok || (new_last == good)],
                                dp[i][last][ok]);
                    }
                }
            }
        }
        int answer = 0;
        for (int last = 0; last < p; last++) {
            answer = add(answer, dp[m][last][1]);
        }
        cout << answer << '\n';
        return;
    }

    for (int quad = 0; quad < p1; quad++) {
        dp[k1][1 << quad][quad & l] = 1;
    }
    for (int i = k1; i < m; i++) {
        for (int mask = 0; mask < cm; mask++) {
            for (int last = 0; last < p; last++) {
                for (int bit = 0; bit <= 1; bit++) {
                    int quad = (last << 1) | bit;
                    dp[i + 1][mask | (1 << quad)][quad & l] =
                        add(dp[i + 1][mask | (1 << quad)][quad & l],
                            dp[i][mask][last]);
                }
            }
        }
    }

    vector<bool> nice(p1, false);
    for (int quad = 0; quad < p1; quad++) {
        if (inside(quad, good, k1, k)) {
            nice[quad] = true;
        }
    }

    vector<int> sum(cm, 0);
    for (int mask = 0; mask < cm; mask++) {
        bool ok = false;
        for (int quad = 0; !ok && quad < p1; quad++) {
            if ((mask & (1 << quad)) != 0 && nice[quad]) {
                ok = true;
            }
        }
        if (!ok) {
            continue;
        }
        for (int last = 0; last < p; last++) {
            sum[mask] = add(sum[mask], dp[n][mask][last]);
        }
    }
    
    vector<int> res(cm, 0);
    for (int mask = 0; mask < cm; mask++) {
        for (int sub = mask; sub != 0; sub = (sub - 1) & mask) {
            res[mask] = add(res[mask], sum[sub]);
        }
    }

    int answer = 0;
    for (int mask = 0; mask < cm; mask++) {
        bool ok = false;
        for (int quad = 0; !ok && quad < p1; quad++) {
            if ((mask & (1 << quad)) != 0 && nice[quad]) {
                ok = true;
            }
        }
        if (!ok) {
            continue;
        }

        int temp = 0;
        for (int last = 0; last < p; last++) {
            temp = add(temp, dp[m][mask][last]);
        }

        int inv_mask = mask ^ (cm - 1);
        answer = add(answer, (ll)temp * res[inv_mask] % MOD);
    }

    cout << answer << '\n';
}

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}